package rocketBugs;
/*  AttenSync ... this object is created by groups of linked/colliding players and 
linkers to assure consistent attenuation of forces
*/

/*  <RocketBugs - for the simulation of actin-based Listeria motility>
    Copyright (C) <2007>  <Jonathan B. Alberts>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.lang.Math.*;

public class AttenSync {
	double atten = 1;

	public AttenSync (double atten) {
		this.atten = atten;
		
	}
	
	public void setAtten (double atten) {
		this.atten = atten;
	}
	
	public boolean checkAtten (double altAtten) {
		if (altAtten > atten) {
			atten = altAtten;
			return true;
		} else {
			return false;
		}
	}
	
	public void attenPt3D (Pt3D pt) {
		pt.scale(1.0/atten);
	}
}
	