package rocketBugs;

import rocketBugs.Collision.ColThreads;

public class FrictionEvent {
	static FrictionEvent [] frictions = new FrictionEvent[10000];
	static int frictionCt = 0;
	static FrictionThreads fricTs = new FrictionThreads ();
	A_Rod fil;
	Listeria bug;
	Pt3D point;
	double mag;
	static double fricScale = 0;
	Pt3D fricF = new Pt3D();
	Pt3D fricFR = new Pt3D();
	
	public FrictionEvent (A_Rod fil, Listeria bug, Pt3D point, double mag) {
		this.fil = fil;
		this.bug = bug;
		this.point = point;
		this.mag = mag;
		addFriction(this);
	}
	
	static class FrictionThreads extends ThreadSet {
		FrictionThreads () {
			super (Env.numberOfFrictionThreads, "Friction Threads");
		}
	
		public void divideAndConquer (int jobId) {
			this.jobId = jobId;
			switch (jobId) {
				case Env.fricStart:
					FrictionEvent.setFrictionForces();
					for (int i=0; i <= numThreads; i++) {
						jobDiv[i] = i*frictionCt/numThreads;	// divide the job amongst threads
					}
					spawn(); break;
			}
			
		}
		
		public void regroup (int jobId) {
			switch (jobId) {
				case Env.fricStop:
					gather(); break;
			}
		}
		
		public void execute (int threadId) {
			switch (jobId) {
				case Env.fricStart:
					for (int i = jobDiv[threadId]; i < jobDiv[threadId+1]; i++) {
						frictions[i].applyFriction();
					}
					break;
			}
		}
	}
	
	public static void setFrictionForces () {
		fricScale = Player.listeria.setFriction();
	}
	
	public void applyFriction () {
		fricF.scale(fricScale*mag,bug.uVec);
		Env.addNormForce(mag);
		Env.addFricForceInx(Math.abs(fricScale*mag));
		fricFR.scale(-1,fricF);
		bug.frictionForce(point, fricF);
		fil.frictionForce(point, fricFR);
	}
	
	public static double fricMag() {
		double magSum = 0;
		for (int i=0;i<frictionCt;i++) {
			magSum += frictions[i].mag;
		}
		return magSum;
	}
	
	public static void addFriction (FrictionEvent nuF) {
		frictions[frictionCt] = nuF;
		frictionCt++;
	}
	
	public static void reset () {
		frictionCt = 0;
	}
}
