package rocketBugs;
/*  A JFrame to get filename */

/*  <RocketBugs - for the simulation of actin-based Listeria motility>
    Copyright (C) <2007>  <Jonathan B. Alberts>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.io.*;

class NameFrame extends JFrame implements ActionListener {
	RocketBugs MC;
	JLabel movieFileNameReq = new JLabel (" Enter Base Filename: ");
	JTextField movieName = new JTextField(15);
	JRadioButton qkType = new JRadioButton ("qk");
	JRadioButton rawType = new JRadioButton ("raw");
	JPanel fileTypePanel = new JPanel();
	JPanel southPanel = new JPanel();
	
	public  NameFrame (RocketBugs MC) {
		this.MC = MC;
		this.setTitle ("Movie Name");
		this.setSize (326,160);
		this.setLocation (150,250);
		this.setResizable(false);
		makeFileTypeButtons();
		makeSouthPanel();
		Container c = getContentPane();
		c.add(fileTypePanel,"West");
		c.add(movieFileNameReq,"Center");
		c.add(movieName,"East");
		c.add(southPanel,"South");
		this.show();
		this.setLocation(150,250);
		movieName.requestFocus();
	}
	
	public void actionPerformed (ActionEvent e) {
		String act = e.getActionCommand();
		if (act.equals("Proceed")) {
			File mvdir = new File (movieName.getText());
			if ((mvdir.isDirectory()) | (movieName.getText().equals(""))) {
				talk ("Sorry, that movie already exists or the name is invalid... please try again");
				movieName.setText("");
			} else {
				if (rawType.isSelected()) { rawMovieSettings (mvdir); }
				if (qkType.isSelected()) { qkMovieSettings (mvdir); }
				dispose();
			}
		}
		if (act.equals("Cancel")) {
			dispose();
		}
	}
	
	public void rawMovieSettings (File mvdir) {
		mvdir.mkdir();
		talk ("Raw pixel movie files will be stored in the directory " + mvdir.getAbsolutePath());
		Env.rawMovieFileName = movieName.getText();
		Env.rawMoviePath = mvdir.getPath();
		Env.rawMovie = true;
		MC.startRawMovieNow = true;
	}
	
	public void qkMovieSettings (File mvdir) {
		mvdir.mkdir();
		talk ("Quick format movie files will be stored in the directory" + mvdir.getAbsolutePath());
		Env.qkMovieFileName = movieName.getText();
		Env.qkMoviePath = mvdir.getPath();
		// make a directory for .dat files
		File datdir = new File (mvdir.getAbsolutePath() + "/" + mvdir.getName() + ".DATA");
		datdir.mkdir();
		Env.datFilePath = datdir.getAbsolutePath();
		//*******
		Env.qkMovie = true;
		MC.fileOps.setUpFiles();
		MC.startQkMovieNow = true;
	}
	
	public void makeFileTypeButtons() {
		qkType.setSelected(true);
		
		ButtonGroup fileTypeGroup = new ButtonGroup();
		fileTypeGroup.add(qkType);
		fileTypeGroup.add(rawType);
		
		qkType.addActionListener(this);
		rawType.addActionListener(this);
		
		fileTypePanel.setLayout(new GridLayout (0,1));
		fileTypePanel.add(qkType);
		fileTypePanel.add(rawType);
	}

	public void makeSouthPanel() {
		JButton proceedButton = new JButton ("Proceed");
		JButton cancelButton = new JButton ("Cancel");
		proceedButton.addActionListener(this);
		cancelButton.addActionListener(this);
		southPanel.add(proceedButton);
		southPanel.add(cancelButton);
	}
		
			
	private void talk (String info) {
		System.out.println(info);
	}
}