package rocketBugs;
/*
	Player Home....class defining the canvas in which the players live
*/

/*  <RocketBugs - for the simulation of actin-based Listeria motility>
    Copyright (C) <2007>  <Jonathan B. Alberts>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.*;
import javax.swing.*;

public class PlayerHome extends JPanel {
	RBFrame theFrame;
	Image theImage;
	Graphics thePalate;
	int width,height;
	double scale;
	PinCam mainCam;
	
	public PlayerHome (int width, int height, RBFrame theFrame) {
		this.width = width;
		this.height = height;
		this.theFrame = theFrame;
		setSize(width,height);
		mainCam = new PinCam (new Pt3D (), new Pt3D (), new Pt3D (0,0,1), 0.0);
		addMouseListener(theFrame);
		addMouseMotionListener(theFrame);
	}
	public void initialize() {
		theImage = createImage(width,height);
		thePalate = theImage.getGraphics();
		scale = Math.min(width/Env.dimensions.x,height/Env.dimensions.y);
	}
	
	public void update(Graphics g) {
		paint(g);
	}
	
	public void paint (Graphics g) {
		g.drawImage(theImage,0,0,null);
	}
	
	public void showPlayers () {
		Player.showAllPlayers(thePalate,scale,mainCam);
	}
	
	public void showLinkers () {
		Linker.showAllLinkers(thePalate,scale,mainCam);
	}
	
	public void showCellInside (SphImpPlayers sphImp) {
		//sphImp.showMemGrid(thePalate,scale);
	}
	
	public void showRocketBugsArea (ZoomFrame zoomFrame) {
		zoomFrame.showRocketBugsArea(thePalate,scale);
	}
	
	public void showStereoArea (StereoFrame stereoFrame) {
		stereoFrame.showStereoArea(thePalate,scale);
	}
	
	public void showElementConc (SphImpPlayers sphImp, int element) {
		//sphImp.showElementConc (thePalate,scale,element);
	}

	public void clearImage() {
		thePalate.setColor(Env.backColor);
		thePalate.fillRect(0,0,width,height);
	}
	private void talk (String info) {
		System.out.println(info);
	}
}

