package rocketBugs;
//*** SurfaceGrid.java   this class is used for storing surface 
// 	  grid locations by ActA

/*  <RocketBugs - for the simulation of actin-based Listeria motility>
    Copyright (C) <2007>  <Jonathan B. Alberts>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

public class SurfaceGrid {
	// this is the object used to store grid point coordinates
	int theta, psi, z;
	double r;
		
	public SurfaceGrid (int psi, int theta, int z, double r) {
		this.psi = psi;				// psi angle steps
		this.theta = theta;			// theta angle steps
		this.z = z;					// steps up cylinder
		this.r = r;					// vector mag or radial length, depending on coordinate sys

				
	}
		
	public SurfaceGrid () {
		psi = 0; theta = 0; z = 0; r = 0;
	}
	
	public boolean inBounds (int psiDim, int thetaDim, int zDim) {
		if ((psi >= psiDim) | (theta >= thetaDim) | (z >= zDim)) {
			//talkln ("A surface grid is out of bounds... " + reportCoords());
			return false;
		} else {
			return true;
		}
	}
	
	public String reportCoords() {
		return("r = " + String.valueOf(r) + ", psi = " + String.valueOf(psi) + ", theta = " + String.valueOf(theta) + ", cylLen = " + String.valueOf(z));
	}
		
	public static void talkln (String info) {
		FileOps.talkln(info);
	}
	
}