package rocketBugs;
/*  ThreadSet ... this class defines a set of Threads that incorporate a barrier, timer, 
and other handy features for multi-threading the simulation
*/

/*  <RocketBugs - for the simulation of actin-based Listeria motility>
    Copyright (C) <2007>  <Jonathan B. Alberts>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

public class ThreadSet {
	ThreadSpawn [] spawn;
	int numThreads;
	Barrier barrier;
	String commandName;
	int jobId;	// integer that defines the task to be performed by threads
	int [] jobDiv;		// delimits array ranges for each thread
	
	
	public ThreadSet (int numThreads, String commandName) {
		this.numThreads = numThreads;
		this.commandName = commandName;
		this.barrier = new Barrier (numThreads, commandName);
		spawn = new ThreadSpawn [numThreads];
		for (int i = 0; i < numThreads; i++) {
			spawn[i] = new ThreadSpawn(i, this);
			spawn[i].setDaemon(true);
			spawn[i].start();
		}
		jobDiv = new int [numThreads+1];
	}
	
	
	class ThreadSpawn extends Thread {
		ThreadSet mySet;
		int threadId;
		
		ThreadSpawn (int threadId, ThreadSet mySet) {
			this.threadId = threadId;
			this.mySet = mySet;
		}
		
		public void run() {
			mySet.done();
			while (true) {
				mySet.execute(threadId);
				mySet.done();
			}
		}
	}
	
	public void divideAndConquer (int jobId) { }
	
	public void regroup (int jobId) { }
	
	public void execute (int threadId) { }
	
	public void spawn () { barrier.startThreads(); }
	public void gather () { barrier.waitOnThreads(); }
	public void done () { barrier.threadDone(); }
}