package rocketBugs;
/* Timer.java  ... a class that keeps track of the time required to execute 
    various sections of code
*/

/*  <RocketBugs - for the simulation of actin-based Listeria motility>
    Copyright (C) <2007>  <Jonathan B. Alberts>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.*;
import java.text.*;

public class Timer {
	long time, startTime, stopTime;
	String commandName, timeString;
	DecimalFormat timeOutFormat = new DecimalFormat ("#00.00#; #00.00#");
	
	public Timer (String commandName) {
		time = 0;
		this.commandName = commandName;
	}
	
	public void start () {
		startTime = java.lang.System.currentTimeMillis();
	}
	
	public void stop () {
		stopTime = java.lang.System.currentTimeMillis();
	}
	
	public void inc () {
		time += stopTime-startTime;
	}
	
	public void reportTime () {
		timeString = String.valueOf(time/1000); //timeOutFormat.format(time/1000));
		talkln (commandName + " took " + timeString + " seconds.");
	}
	
	private void talkln (String info) {
		System.out.println(info);
	}
}